package me.zhengjie.config.rabbitmq.test;

import com.alibaba.fastjson.JSONArray;
import me.zhengjie.config.rabbitmq.cuisine.CuisineConsumer;
import me.zhengjie.config.rabbitmq.cuisine.CuisineProduce;
import me.zhengjie.config.rabbitmq.order.OrderConsumer;
import me.zhengjie.config.rabbitmq.order.OrederProduce;
import me.zhengjie.modules.dm.daypc.domain.DmDayPc;
import me.zhengjie.modules.dm.daypc.service.DmDayPcService;
import me.zhengjie.modules.dm.food.service.DmFoodService;
import me.zhengjie.modules.dm.order.service.DmOrderRecordService;
import me.zhengjie.modules.dm.order.service.dto.DmExpenseCalendar;
import org.springframework.amqp.rabbit.annotation.RabbitListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.amqp.core.Message;

import java.sql.Timestamp;
import java.util.List;

@Configurable
public class ListenerTemplate {
    @Autowired
    DmDayPcService dmDayPcService;
    @Autowired
    DmFoodService dmFoodService;
    @Autowired
    DmOrderRecordService dmOrderRecordService;

    @RabbitListener(queues = CuisineConsumer.NAME, containerFactory = CuisineConsumer.LISTENER_CON)
    public void dealDeclareMessage(Message message) {
        System.out.println("接受到的消息pc"+message);
        String str = String.valueOf(message);
        if (str!=null){
            System.out.println("receive:"+str);
        }else {
            System.out.println("receive(null):"+ str);
        }
        try {
            List<DmDayPc> list = JSONArray.parseArray(str, DmDayPc.class);
            for (DmDayPc dmDayPc : list) {
                dmDayPc.setPcdate(new Timestamp(System.currentTimeMillis()));
                dmDayPcService.create(dmDayPc);
                System.out.println("新增food===" + dmDayPc.getFood());
                dmFoodService.create(dmDayPc.getFood());
            }
        }catch (Exception ex){

        }
    }

    @RabbitListener(queues = OrderConsumer.NAME_ORDER, containerFactory = OrderConsumer.LISTENER_ORDER_CON)
    public void dealDeclareOrderMessage(Message message) {
        System.out.println("接受到的消息order"+message);
        String str = String.valueOf(message);
        if (str!=null){
            System.out.println("receiveOrder:"+str);
        }else {
            System.out.println("receiveOrder(null):"+ str);
        }
        try {
            List<DmExpenseCalendar> dmOrderItem = JSONArray.parseArray(str, DmExpenseCalendar.class);
            for (DmExpenseCalendar dmExpenseCalendar : dmOrderItem) {
                dmOrderRecordService.createOrderItem(dmExpenseCalendar);
                dmOrderRecordService.createOrderRecord(dmExpenseCalendar);
            }
        }catch (Exception ex){

        }
    }
}
